![unipi logo](https://github.com/UniPiTechnology/evok/raw/master/www/evok/js/jquery/images/unipi-logo-short-cmyk.svg?sanitize=true "Unipi logo")

# EVOK - the Unipi API

EVOK is the primary API for accessing I/Os of [NEURON], [PATRON], [GATE] and [Unipi 1.1] devices including [Extension modules] by [Unipi technology].

It provides multiple ways to easilly access the I/Os of the devices, including:
- RESTful WebForms API
- RESTful JSON API
- Bulk request JSON API
- WebSocket API
- JSON-RPC API

Besides that, EVOK also supports sending notifications via webhook.

[evok-web] is a simple demo web application using Evok demonstrating its usage and allowing easy controll of the devices configured in Evok.

# Getting started
- [Installation instructions](./docs/installation.md) - How to install evok on Unipi controllers
- [Debugging](./docs/debugging.md) - How to debugging evok
- [APIs](./docs/apis.md) - List of supported evok apis
  - [REST API](./docs/apis/rest.md)
  - [JSON API](./docs/apis/json.md)
  - [BULK API](./docs/apis/bulk.md)
  - [Websocket](./docs/apis/websocket.md)
  - [RPC API](./docs/apis/rpc.md)
  - [Webhook](./docs/apis/webhook.md)
- Configurations:
  - [Evok configuration](./docs/configs/evok_configuration.md) - How to configure evok devices and apis
  - [HW_definitions](./docs/configs/hw_definitions.md) - How to configure Modbus map definitions
  - [Aliases](./docs/configs/aliases.md) - How Evok aliases works


# Major changes between Evok v2 and v3:
- Evok v3 is based on Python3.
- Updating Evok from v2 to v3 is unsupported.
- Migration from Debian 10 is unsupported and it's recommended to start from a fresh operating system.
- The configuration of Evok has been completely rewritten to yaml. Hardware configuration is using tree structure. See more information in the [evok configuration](./docs/configs/evok_configuration.md).
- The device names in the API now match the name in the configuration. For more information see [evok configuration](./docs/configs/evok_configuration.md).
- [Aliases](./docs/configs/aliases.md) system of I/Os has been rewritten and are saved 5mins after change, not immediately. Saving can be fored via API.
- Structure of the aliases configuration file has been changed. Evok automatically updates the configuration file if an old version is loaded.
- Added option 'all' instead of circuit using API (/rest/relay/all).
- The mod switching method for AO and AI has been changed. Now the measured value and the range are not set separately, but one mode represents a combination of both properties.
- Modbus RTU durability has been improved. Loss of communication with one device will not affect the functionality of the entire bus.


## Developer Note

Do you feel like contributing to EVOK, or perhaps have a neat idea for an improvement to our system? Feel free to open to contribute to this repository.

License
============
Apache License, Version 2.0

[PUTTY]:http://www.putty.org/
[github repository]:https://github.com/UniPiTechnology/evok
[OpenSource image]:https://files.unipi.technology/s/public?path=%2FSoftware%2FOpen-Source%20Images
[IndieGogo]:https://www.indiegogo.com/projects/unipi-the-universal-raspberry-pi-add-on-board
[NEURON]:https://www.unipi.technology/products/unipi-neuron-3?categoryId=2
[PATRON]:https://www.unipi.technology/products/unipi-patron-374
[GATE]:https://www.unipi.technology/products/unipi-gate-388
[Unipi 1.1]:https://www.unipi.technology/products/unipi-1-1-1-1-lite-19?categoryId=1
[tornado]:https://pypi.python.org/pypi/tornado/
[toro]:https://pypi.python.org/pypi/toro/
[tornardorpc]:https://github.com/joshmarshall/tornadorpc
[websocket Python library]:https://pypi.python.org/pypi/websocket-client/
[intructions below]:https://github.com/UniPiTechnology/evok#installing-evok-for-neuron
[jsonrpclib]:https://github.com/joshmarshall/jsonrpclib
[Evok-web]:https://github.com/UniPiTechnology/evok-web-jq
[Extension modules]:https://www.unipi.technology/products?category=32
[Unipi technology]:https://www.unipi.technology/
